from cropclass.openeo.classification import load_cropclass_udf
from cropclass.openeo.preprocessing import cropclass_preprocessed_inputs


def croptype_map(extent,year,connection,collections_options,processing_options):
    STARTDATE = 'YYYY-04-01'.replace('YYYY',str(year))
    ENDDATE = 'YYYY-10-31'.replace('YYYY',str(year))

    inputs = cropclass_preprocessed_inputs(
        connection,
        extent,
        STARTDATE,
        ENDDATE, **collections_options,**processing_options)


    context = {
        'startdate': STARTDATE,
        'enddate': ENDDATE,
        'worldcovermask': False,
        'modeldir': processing_options.get('modeldir', 'tmp/model/'),
        'modeltag': processing_options.get('modeltag', '20221102T134330-transformer_optical_sar_dem'),
        'custom_dependency_path': processing_options.get('custom_dependency_path','')

    }

    cropclass_udf = load_cropclass_udf()

    # Define the classification step (note: we don't actually start it here)
    clf_results = inputs.reduce_dimension(
        dimension='t',
        reducer=lambda data: data.run_udf(
            cropclass_udf,
            context=context,
            runtime='Python'
        )
    ).linear_scale_range(0, 10000, 0, 10000)
    return clf_results